require("gui_actions")
require("gui_creation")


script.on_init(
function()
    for index, player in pairs(game.players) do --in case the mod was added to a save.
        global.player_mail = {}
        global.player_mail[index] = {}
        nukeAndRegenUI(player)
        table.insert(global.player_mail[index], {subject = "You've Got Mail init", player = "None", message = "Welcome to your inbox, you receive mail to read here."})
    end
end
)

script.on_event({defines.events.on_player_created},
function(e)
    global.player_mail = global.player_mail or {}
    global.player_mail[e.player_index] = {}

    table.insert(global.player_mail[e.player_index],
    {subject = "You've Got Mail init", player = "None", message = "Welcome to your inbox, you receive mail to read here."})

    nukeAndRegenUI(game.players[e.player_index])
end
)

script.on_configuration_changed(
function()
    for index, player in pairs(game.players) do --in case the mod was added to a save.
        global.player_mail = global.player_mail or {}
        global.player_mail[index] = global.player_mail[index] or {}
        nukeAndRegenUI(player)
    end
end
)

script.on_event({defines.events.on_player_joined_game},
function(event)
    nukeAndRegenUI(game.players[event.player_index])
    local player = game.players[event.player_index]
    if #global.player_mail[player.index] ~= 0 then
        player.print("You've got mail!")
        player.gui.left["ygm-open-mail-list-button"].sprite = "ygm-new-mail-sprite"
    end
end
)

function mailAllUsers(event)
    local player = game.players[event.player_index]
    if not player.admin then
        player.print("Player is not an admin, denied.")
        return
    end
    for index, player in pairs(game.players) do
        sendMail(player.name, "[B] " .. event.parameter:sub(1, 40), event.parameter, game.players[event.player_index].name)
    end
end

commands.add_command("mailAll", "Send mail to all users. Provide message as a parameter. Admin only.", mailAllUsers)
